module Sungemm
  class HashWithIndifferentAccess
    def initialize(args = [])
      @hash = {}
      args.each_slice(2) do |x|
        k = x[0].to_sym
        v = x[1].nil? ? nil : x[1]
        @hash[k] = v
      end
    end

    def self.[](*args)
      new(args)
    end

    def []=(key, value)
      @hash[key.to_sym] = value
    end

    def [](key)
      @hash[key.to_sym]
    end
  end
end
