module Sungemm
  class Stack
    def initialize(array)
      @array = array
    end

    def pop(count = 1)
      r = @array.pop(count).reverse
      r = r.last if count == 1
      r
    end

    def push(values)
      values.each { |x| @array << x }
      true
    end

    def to_a
      @array
    end
  end
end
